/*
 * В этом модуле представлены базовые функции для
 * генерации информации о сигнатурах и резервирования ресурсов.
 */

char *
new_string(const char * format, ...);

void
gen_error(const char * fmt, ...);



char *
jvm_get_descriptor(oberon_type_t * type);

char
jvm_get_prefix(oberon_type_t * type);

char
jvm_get_postfix(oberon_type_t * type);

char *
jvm_get_name(oberon_object_t * x);

char *
jvm_get_field_full_name(oberon_object_t * x);

char *
jvm_get_field_full_name_safe(oberon_object_t * x);

char *
jvm_get_class_full_name(oberon_type_t * type);

char *
jvm_get_procedure_signature(oberon_type_t * proc);



int
jvm_cell_size_for_type(oberon_type_t * type);

int
jvm_cell_size_for_postfix(char postix);

bool
jvm_is_wide_type(oberon_type_t * type);

bool
jvm_is_free_register(struct gen_register_file * rf, int i, bool wide);

int
jvm_alloc_register_untyped(struct gen_register_file * rf, bool wide);

int
jvm_alloc_register(struct gen_register_file * rf, oberon_type_t * type);



char
jvm_get_type_of_prefix(char prefix);
